Index: sockit/atari800core_sockit.vhdl
===================================================================
--- sockit/atari800core_sockit.vhdl	(revision 310)
+++ sockit/atari800core_sockit.vhdl	(revision 311)
@@ -246,26 +465,227 @@
 		SDRAM_8BIT_WRITE_ENABLE => open,
 		SDRAM_REFRESH => open,
 
-		DMA_FETCH => '0',
-		DMA_READ_ENABLE => '0',
-		DMA_32BIT_WRITE_ENABLE => '0',
+		DMA_FETCH => atari_dma_fetch,
+		DMA_READ_ENABLE => atari_dma_read_enable,
+		DMA_32BIT_WRITE_ENABLE => atari_dma_32bit_write_enable,
 		DMA_16BIT_WRITE_ENABLE => '0',
-		DMA_8BIT_WRITE_ENABLE => '0',
-		DMA_ADDR => (others=>'0'),
-		DMA_WRITE_DATA => (others=>'0'),
-		MEMORY_READY_DMA => open,
-		DMA_MEMORY_DATA => open,
+		DMA_8BIT_WRITE_ENABLE => atari_dma_8bit_write_enable,
+		DMA_ADDR => atari_dma_addr,
+		DMA_WRITE_DATA => atari_dma_write_data,
+		MEMORY_READY_DMA => atari_memory_ready_dma,
+		DMA_MEMORY_DATA => atari_dma_memory_data,
 
 		-- Special config params
-   		RAM_SELECT => (others=>'0'), -- 64K,128K,320KB Compy, 320KB Rambo, 576K Compy, 576K Rambo, 1088K, 4MB
-    		ROM_SELECT => "000001",
+   	RAM_SELECT => ram_select,
+    	ROM_SELECT => rom_select,
 		PAL => '1',
-		HALT => '0',
-		THROTTLE_COUNT_6502 => "000001",
-		emulated_cartridge_select => (others=>'0'),
-		freezer_enable => '0',
-		freezer_activate => '0'
+		HALT => pause_atari,
+		THROTTLE_COUNT_6502 => speed_6502,
+		emulated_cartridge_select => emulated_cartridge_select,
+		freezer_enable => freezer_enable,
+		freezer_activate => freezer_activate
 	);
 
+    hps_bridge : component atari_hps
+        port map (
+            clk_clk                               => CLK,                               --             clk.clk
+            hps_0_h2f_reset_reset_n               => open,               -- hps_0_h2f_reset.reset_n
+            hps_0_hps_io_hps_io_emac1_inst_TX_CLK => HPS_ENET_GTX_CLK, --    hps_0_hps_io.hps_io_emac1_inst_TX_CLK
+            hps_0_hps_io_hps_io_emac1_inst_TXD0   => HPS_ENET_TX_DATA(0),   --                .hps_io_emac1_inst_TXD0
+            hps_0_hps_io_hps_io_emac1_inst_TXD1   => HPS_ENET_TX_DATA(1),   --                .hps_io_emac1_inst_TXD1
+            hps_0_hps_io_hps_io_emac1_inst_TXD2   => HPS_ENET_TX_DATA(2),   --                .hps_io_emac1_inst_TXD2
+            hps_0_hps_io_hps_io_emac1_inst_TXD3   => HPS_ENET_TX_DATA(3),   --                .hps_io_emac1_inst_TXD3
+            hps_0_hps_io_hps_io_emac1_inst_RXD0   => HPS_ENET_RX_DATA(0),   --                .hps_io_emac1_inst_RXD0
+            hps_0_hps_io_hps_io_emac1_inst_MDIO   => HPS_ENET_MDIO,   --                .hps_io_emac1_inst_MDIO
+            hps_0_hps_io_hps_io_emac1_inst_MDC    => HPS_ENET_MDC,    --                .hps_io_emac1_inst_MDC
+            hps_0_hps_io_hps_io_emac1_inst_RX_CTL => HPS_ENET_RX_DV, --                .hps_io_emac1_inst_RX_CTL
+            hps_0_hps_io_hps_io_emac1_inst_TX_CTL => HPS_ENET_TX_EN, --                .hps_io_emac1_inst_TX_CTL
+            hps_0_hps_io_hps_io_emac1_inst_RX_CLK => HPS_ENET_RX_CLK, --                .hps_io_emac1_inst_RX_CLK
+            hps_0_hps_io_hps_io_emac1_inst_RXD1   => HPS_ENET_RX_DATA(1),   --                .hps_io_emac1_inst_RXD1
+            hps_0_hps_io_hps_io_emac1_inst_RXD2   => HPS_ENET_RX_DATA(2),   --                .hps_io_emac1_inst_RXD2
+            hps_0_hps_io_hps_io_emac1_inst_RXD3   => HPS_ENET_RX_DATA(3),   --                .hps_io_emac1_inst_RXD3
+            hps_0_hps_io_hps_io_qspi_inst_IO0     => HPS_FLASH_DATA(0),     --                .hps_io_qspi_inst_IO0
+            hps_0_hps_io_hps_io_qspi_inst_IO1     => HPS_FLASH_DATA(1),     --                .hps_io_qspi_inst_IO1
+            hps_0_hps_io_hps_io_qspi_inst_IO2     => HPS_FLASH_DATA(2),     --                .hps_io_qspi_inst_IO2
+            hps_0_hps_io_hps_io_qspi_inst_IO3     => HPS_FLASH_DATA(3),     --                .hps_io_qspi_inst_IO3
+            hps_0_hps_io_hps_io_qspi_inst_SS0     => HPS_FLASH_NCSO,     --                .hps_io_qspi_inst_SS0
+            hps_0_hps_io_hps_io_qspi_inst_CLK     => HPS_FLASH_DCLK,     --                .hps_io_qspi_inst_CLK
+            hps_0_hps_io_hps_io_sdio_inst_CMD     => HPS_SD_CMD,     --                .hps_io_sdio_inst_CMD
+            hps_0_hps_io_hps_io_sdio_inst_D0      => HPS_SD_DATA(0),      --                .hps_io_sdio_inst_D0
+            hps_0_hps_io_hps_io_sdio_inst_D1      => HPS_SD_DATA(1),      --                .hps_io_sdio_inst_D1
+            hps_0_hps_io_hps_io_sdio_inst_CLK     => HPS_SD_CLK,     --                .hps_io_sdio_inst_CLK
+            hps_0_hps_io_hps_io_sdio_inst_D2      => HPS_SD_DATA(2),      --                .hps_io_sdio_inst_D2
+            hps_0_hps_io_hps_io_sdio_inst_D3      => HPS_SD_DATA(3),      --                .hps_io_sdio_inst_D3
+            hps_0_hps_io_hps_io_usb1_inst_D0      => HPS_USB_DATA(0),      --                .hps_io_usb1_inst_D0
+            hps_0_hps_io_hps_io_usb1_inst_D1      => HPS_USB_DATA(1),      --                .hps_io_usb1_inst_D1
+            hps_0_hps_io_hps_io_usb1_inst_D2      => HPS_USB_DATA(2),      --                .hps_io_usb1_inst_D2
+            hps_0_hps_io_hps_io_usb1_inst_D3      => HPS_USB_DATA(3),      --                .hps_io_usb1_inst_D3
+            hps_0_hps_io_hps_io_usb1_inst_D4      => HPS_USB_DATA(4),      --                .hps_io_usb1_inst_D4
+            hps_0_hps_io_hps_io_usb1_inst_D5      => HPS_USB_DATA(5),      --                .hps_io_usb1_inst_D5
+            hps_0_hps_io_hps_io_usb1_inst_D6      => HPS_USB_DATA(6),      --                .hps_io_usb1_inst_D6
+            hps_0_hps_io_hps_io_usb1_inst_D7      => HPS_USB_DATA(7),      --                .hps_io_usb1_inst_D7
+            hps_0_hps_io_hps_io_usb1_inst_CLK     => HPS_USB_CLKOUT,     --                .hps_io_usb1_inst_CLK
+            hps_0_hps_io_hps_io_usb1_inst_STP     => HPS_USB_STP,     --                .hps_io_usb1_inst_STP
+            hps_0_hps_io_hps_io_usb1_inst_DIR     => HPS_USB_DIR,     --                .hps_io_usb1_inst_DIR
+            hps_0_hps_io_hps_io_usb1_inst_NXT     => HPS_USB_NXT,     --                .hps_io_usb1_inst_NXT
+            hps_0_hps_io_hps_io_spim0_inst_CLK    => HPS_LCM_SPIM_CLK,    --                .hps_io_spim0_inst_CLK
+            hps_0_hps_io_hps_io_spim0_inst_MOSI   => HPS_LCM_SPIM_MOSI,   --                .hps_io_spim0_inst_MOSI
+            hps_0_hps_io_hps_io_spim0_inst_MISO   => HPS_LCM_SPIM_MISO,   --                .hps_io_spim0_inst_MISO
+            hps_0_hps_io_hps_io_spim0_inst_SS0    => HPS_LCM_SPIM_SS,    --                .hps_io_spim0_inst_SS0
+            hps_0_hps_io_hps_io_spim1_inst_CLK    => HPS_SPIM_CLK,    --                .hps_io_spim1_inst_CLK
+            hps_0_hps_io_hps_io_spim1_inst_MOSI   => HPS_SPIM_MOSI,   --                .hps_io_spim1_inst_MOSI
+            hps_0_hps_io_hps_io_spim1_inst_MISO   => HPS_SPIM_MISO,   --                .hps_io_spim1_inst_MISO
+            hps_0_hps_io_hps_io_spim1_inst_SS0    => HPS_SPIM_SS,    --                .hps_io_spim1_inst_SS0
+            hps_0_hps_io_hps_io_uart0_inst_RX     => HPS_UART_RX,     --                .hps_io_uart0_inst_RX
+            hps_0_hps_io_hps_io_uart0_inst_TX     => HPS_UART_TX,     --                .hps_io_uart0_inst_TX
+            hps_0_hps_io_hps_io_i2c1_inst_SDA     => HPS_I2C_SDA,     --                .hps_io_i2c1_inst_SDA
+            hps_0_hps_io_hps_io_i2c1_inst_SCL     => HPS_I2C_CLK,     --                .hps_io_i2c1_inst_SCL
+				memory_mem_a => HPS_DDR3_A, -- memory.mem_a
+				memory_mem_ba => HPS_DDR3_BA, -- .mem_ba
+				memory_mem_ck => HPS_DDR3_CK_P, -- .mem_ck
+				memory_mem_ck_n => HPS_DDR3_CK_N, -- .mem_ck_n
+				memory_mem_cke => HPS_DDR3_CKE, -- .mem_cke
+				memory_mem_cs_n => HPS_DDR3_CS_N, -- .mem_cs_n
+				memory_mem_ras_n => HPS_DDR3_RAS_N, -- .mem_ras_n
+				memory_mem_cas_n => HPS_DDR3_CAS_N, -- .mem_cas_n
+				memory_mem_we_n => HPS_DDR3_WE_N, -- .mem_we_n
+				memory_mem_reset_n => HPS_DDR3_RESET_N, -- .mem_reset_n
+				memory_mem_dq => HPS_DDR3_DQ, -- .mem_dq
+				memory_mem_dqs => HPS_DDR3_DQS_P, -- .mem_dqs
+				memory_mem_dqs_n => HPS_DDR3_DQS_N, -- .mem_dqs_n
+				memory_mem_odt => HPS_DDR3_ODT, -- .mem_odt
+				memory_mem_dm => HPS_DDR3_DM, -- .mem_dm
+				memory_oct_rzqin => HPS_DDR3_RZQ, -- .oct_rzqin
+            reset_reset_n                         => PLL_LOCKED,                         --           reset.reset_n
+				atari_dma_dma_fetch => atari_dma_fetch,
+				atari_dma_dma_read_enable => atari_dma_read_enable,
+				atari_dma_dma_32bit_write_enable => atari_dma_32bit_write_enable,
+				atari_dma_dma_8bit_write_enable => atari_dma_8bit_write_enable,
+				atari_dma_dma_addr => atari_dma_addr,
+				atari_dma_dma_write_data => atari_dma_write_data,
+				atari_dma_memory_ready_dma => atari_memory_ready_dma,
+				atari_dma_dma_memory_data => atari_dma_memory_data,
+            arm_regs_pokey_enable                 => pokey_enable,                 --        arm_regs.pokey_enable
+            arm_regs_in1                          => X"000"&
+			"00"&ps2_keys(16#76#)&ps2_keys(16#5A#)&ps2_keys(16#174#)&ps2_keys(16#16B#)&ps2_keys(16#172#)&ps2_keys(16#175#)& -- (esc)FLRDU
+			FKEYS,                          --                .in1
+            arm_regs_in2                          => (others=>'0'),                          --                .in2
+            arm_regs_in3                          => (others=>'0'),                          --                .in3
+            arm_regs_in4                          => (others=>'0'),                          --                .in4
+            arm_regs_out1                         => out1,                         --                .out1
+            arm_regs_out2                         => out2,                         --                .out2
+            arm_regs_out3                         => out3,                         --                .out3
+            arm_regs_out4                         => out4,                         --                .out4
+            arm_regs_out5                         => out5,                         --                .out5
+            arm_regs_out6                         => out6,                         --                .out6
+            arm_regs_sio_data_in                  => sio_data_in,                  --                .sio_data_in
+            arm_regs_sio_command                  => sio_command,                  --                .sio_command
+            arm_regs_sio_data_out                 => sio_data_out                  --                .sio_data_out				
+		);	
+
+	pause_atari <= out1(0);
+	reset_atari <= out1(1);
+	speed_6502 <= out1(7 downto 2);
+	ram_select <= out1(10 downto 8);
+	rom_select <= out1(16 downto 11);
+	emulated_cartridge_select <= out1(22 downto 17);
+	freezer_enable <= out1(25);
+
+	JOY1 <= out2(5 downto 4)&out2(0)&out2(1)&out2(2)&out2(3);
+	JOY2 <= out3(5 downto 4)&out3(0)&out3(1)&out3(2)&out3(3);
+	
+	JOY1X <= out5(7 downto 0);
+	JOY1Y <= out5(15 downto 8);
+	JOY2X <= out5(23 downto 16);
+	JOY2Y <= out5(31 downto 24);
+	
+	process(paddle_mode_reg, joy1, joy2)
+	begin
+		joy1_n <= (others=>'1');
+		joy2_n <= (others=>'1');
+
+		if (paddle_mode_reg = '1') then
+			joy1_n <= "111"&not(joy1(4)&joy1(5)); --FLRDU
+			joy2_n <= "111"&not(joy2(4)&joy2(5));
+		else
+			joy1_n <= not(joy1(4 downto 0));
+			joy2_n <= not(joy2(4 downto 0));
+		end if;
+	end process;
+
+	paddle_mode_next <= paddle_mode_reg xor (not(ps2_keys(16#11F#)) and ps2_keys_next(16#11F#)); -- left windows key	
+
+keyboard_map1 : entity work.ps2_to_atari800
+	GENERIC MAP
+	(
+		ps2_enable => 0,
+		direct_enable => 1
+	)
+	PORT MAP
+	( 
+		CLK => clk,
+		RESET_N => reset_n,
+		
+		INPUT => out4,
+		
+		KEYBOARD_SCAN => KEYBOARD_SCAN,
+		KEYBOARD_RESPONSE => KEYBOARD_RESPONSE,
+
+		CONSOL_START => CONSOL_START,
+		CONSOL_SELECT => CONSOL_SELECT,
+		CONSOL_OPTION => CONSOL_OPTION,
+		
+		FKEYS => FKEYS,
+		FREEZER_ACTIVATE => freezer_activate,
+		
+		PS2_KEYS_NEXT_OUT => ps2_keys_next,
+		PS2_KEYS => ps2_keys
+	);
+
+-- hack for paddles
+	process(clk,PLL_LOCKED)
+	begin
+		if (PLL_LOCKED = '0') then
+			paddle_mode_reg <= '0';
+		elsif (clk'event and clk='1') then
+			paddle_mode_reg <= paddle_mode_next;
+		end if;
+	end process;
+	
+	enable_179_clock_div_zpu_pokey : entity work.enable_divider
+	generic map (COUNT=>32) -- cycle_length
+	port map(clk=>clk,reset_n=>reset_n,enable_in=>'1',enable_out=>pokey_enable);
+
+-- sound
+audio_codec_config_over_i2c : entity work.i2c_loader
+GENERIC MAP(device_address => 26,
+			log2_divider => 6,
+			num_retries => 0
+			)
+PORT MAP(CLK => CLK,
+		 nRESET => PLL_LOCKED,
+		 I2C_SCL => AUD_I2C_SCLK,
+		 I2C_SDA => AUD_I2C_SDAT);
+
+audio_codec_data : entity work.i2sslave
+PORT MAP(CLK_HALF => CLK_HALF,
+		 BCLK => AUD_BCLK,
+		 DACLRC => AUD_DACLRCK,
+		 LEFT_IN => '0'&AUDIO_LEFT(15 downto 1), -- TODO...
+		 RIGHT_IN => '0'&AUDIO_RIGHT(15 downto 1),
+		 MCLK_2 => AUD_XCK,
+		 DACDAT => AUD_DACDAT);
+
+	AUD_ADCDAT <= 'Z';
+	AUD_ADCLRCK <= 'Z';
+	--AUD_BCLK <= 'Z';
+	--AUD_DACDAT <= '0';
+	--AUD_DACLRCK <= 'Z';
+	AUD_MUTE <= '1';
+	--AUD_XCK <= '0';
+
+--	AUD_I2C_SCLK <= '0';
+--	AUD_I2C_SDAT <= 'Z';
+
 END vhdl;
 
